//
//  YGViewController.m
//  TextKit
//
//  Created by yagom on 13. 10. 10..
//  Copyright (c) 2013년 yagom. All rights reserved.
//

#import "YGViewController.h"

@interface YGViewController ()
@property (weak, nonatomic) IBOutlet UILabel *titleLabel;
@property (weak, nonatomic) IBOutlet UITextView *textView;
@property (weak, nonatomic) IBOutlet UIView *squareView;

@end

@implementation YGViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    // Title Label의 폰트를 시스템이 지정한 헤드라인 스타일로 지정해 줍니다.
    [self.titleLabel setFont:[UIFont preferredFontForTextStyle:UIFontTextStyleHeadline]];
    
    // 텍스트 뷰에서 보여질 폰트입니다.
    UIFont *textFont = [UIFont preferredFontForTextStyle:UIFontTextStyleBody];
    
    // 텍스트 뷰에서 보여질 텍스트 색상입니다.
    UIColor *textColor = [UIColor darkGrayColor];
    
    // 딕셔너리 형태로 텍스트 속성을 만듭니다. 미리 만들어 놓은 색상, 폰트, 그리고 추가적으로 효과까지 넣습니다.
    // 레터 프레스 스타일로 텍스트 스타일을 지정했습니다.
    NSDictionary *attributes = @{NSForegroundColorAttributeName:textColor, NSFontAttributeName:textFont, NSTextEffectAttributeName:NSTextEffectLetterpressStyle};
    
    // 텍스트뷰의 텍스트를 가지고 속성이 추가된 문자열을 만듭니다.
    NSAttributedString *attributedString = [[NSAttributedString alloc] initWithString:self.textView.text attributes:attributes];
    
    // 속성이 추가된 문자열을 텍스트뷰에 세팅해줍니다.
    [self.textView setAttributedText:attributedString];

    // 텍스트뷰를 가리는 뷰의 영역 객체를 만듭니다.
    UIBezierPath *squarePath = [UIBezierPath bezierPathWithRect:self.squareView.frame];
    
    // 텍스트 뷰의 텍스트가 피해가야 할 영역들을 지정해 줍니다.
    [self.textView.textContainer setExclusionPaths:@[squarePath]];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
